<?php
/*
Plugin Name: Berri Technorati Reactions on Dashboard
Plugin URI: http://www.berriart.com/technorati-reactions-dashboard-plugin/
Description: Shows on the Dashboard the Technorati Reactions of your blog. Widget for the main admin page.
Author: Alberto Varela
Version: 2.0
Author URI: http://www.berriart.com

	My plugin is released under the GNU General Public License (GPL)
	http://www.gnu.org/licenses/gpl.txt
*/

/******************************************************************************

Copyright 2008  Alberto Varela  (email : alberto@berriart.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
The license is also available at http://www.gnu.org/copyleft/gpl.html

*********************************************************************************/

// Added to make it compatible with the plugin "Dashboard Widget Manager". Thanks to http://www.viper007bond.com/
require_once( ABSPATH . WPINC . '/rss.php' );

// Register Dashboard Widget
add_action('wp_dashboard_setup', 'berriTechnoratiReactions_register_dashboard_widget');
function berriTechnoratiReactions_register_dashboard_widget() {
	wp_register_sidebar_widget('dashboard_berriTechnoratiReactions', __('Technorati Reactions', 'berriTechnoratiReactions'), 'dashboard_berriTechnoratiReactions',
		array(
		'all_link' => "http://www.technorati.com/search/".trailingslashit(get_option('home')), 
		'feed_link' => "http://feeds.technorati.com/cosmos/rss/?url=". trailingslashit(get_option('home')) ."&partner=wordpress", 
		'width' => 'half', // OR 'fourth', 'third', 'half', 'full' (Default: 'half')
		'height' => 'single', // OR 'single', 'double' (Default: 'single')
		)
	);
}
 
// Add Dashboard Widget
add_filter('wp_dashboard_widgets', 'berriTechnoratiReactions_add_dashboard_widget');
function berriTechnoratiReactions_add_dashboard_widget($widgets) {
	global $wp_registered_widgets;
	if (!isset($wp_registered_widgets['dashboard_berriTechnoratiReactions'])) {
		return $widgets;
	}
	array_splice($widgets, sizeof($widgets)-1, 0, 'dashboard_berriTechnoratiReactions');
	return $widgets;
}
 
// Print Dashboard Widget
function dashboard_berriTechnoratiReactions($sidebar_args) {
	global $wpdb;
	$tech_rss_feed = "http://feeds.technorati.com/cosmos/rss/?url=". trailingslashit(get_option('home')) ."&partner=wordpress";
	extract($sidebar_args, EXTR_SKIP);
	echo $before_widget;
	echo $before_title;
	echo $widget_name;
	echo $after_title;
	echo "<ul>";
	$rss = @fetch_rss($tech_rss_feed);
	$rss->items = array_slice($rss->items, 0, 8);
	foreach ($rss->items as $item ) {
		$parsed_url = parse_url(wp_filter_kses($item['link']));
		echo "<li><a href=" . wp_filter_kses($item['link']) . ">" . wptexturize(wp_specialchars($item['title'])) . "</a> - [" . $parsed_url['host'] . "]</li>";
	}
	echo "</ul>";
	echo $after_widget;
}

?>
